<template>
  <div class="mt-form-fields-utilisateur">
    <div class="mt-fields-section">
      <h3 class="has-text-weight-bold">Informations sur l’utilisateur</h3>
      <div class="columns">
        <div class="column">
          <b-field label="Nom ">
            <b-input v-model="utilisateur.nom" placeholder="Ex: Dupont" required />
          </b-field>
        </div>
        <div class="column">
          <b-field label="Prénom ">
            <b-input v-model="utilisateur.prenom" placeholder="Ex: Jean" required />
          </b-field>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <b-field label="Email / Identifiant">
            <b-input v-model="utilisateur.email" placeholder="Ex: jean.dupont@server.com" type="email" required />
          </b-field>
        </div>
        <div class="column">
          <b-field label="Téléphone ">
            <b-input v-model="utilisateur.telephone" placeholder="Ex: 0123456789" required />
          </b-field>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <b-field label="Catégorie ">
            <b-select v-model="utilisateur.corps.id" placeholder="Sélectionner une catégorie" expanded required>
              <option v-for="corp in corps" :key="corp.id" :value="corp.id">
                {{ corp.libelle }}
              </option>
            </b-select>
          </b-field>
        </div>
      </div>
    </div>
    <div class="mt-fields-section">
      <h3 class="has-text-weight-bold">Affectation</h3>
      <div class="columns">
        <div v-for="(typeOrganisme, index) in typesOrganismes" :key="index" class="column">
          <b-field :label="typeOrganisme.libelle">
            <b-select
              v-model="organismes[index]"
              :disabled="isUpdateOrganismeDisabled(typeOrganisme.id)"
              :placeholder="typeOrganisme.libelle"
              expanded
              :required="!isAdmin"
              @input="majTypeOrganisme(index)"
            >
              <option v-for="organisme in typeOrganisme.organismes" :key="organisme.id" :value="organisme.id">
                {{ organisme.code }}
              </option>
            </b-select>
          </b-field>
        </div>
      </div>
      <div class="columns">
        <div class="column">
          <b-field label="Date d'affectation">
            <b-datepicker
              v-model="utilisateur.affectation.dateAffectation"
              placeholder="Sélectionnez une date d'affectation"
              :first-day-of-week="1"
              :month-names="monthNames"
              :day-names="dayNames"
              :date-parser="dateParse"
              editable
              icon="calendar-today"
              autocomplete="off"
            />
          </b-field>
        </div>
        <div class="column">
          <b-field label="Poste au Ro ">
            <b-select v-model="utilisateur.affectation.posteRo.id" placeholder="Sélectionner un poste" expanded>
              <option :value="null">
                ---
              </option>
              <option v-for="pro in postesRo" :key="pro.id" :value="pro.id">
                {{ pro.libelle }}
              </option>
            </b-select>
          </b-field>
        </div>
      </div>
    </div>
    <div class="mt-fields-section">
      <h3 class="has-text-weight-bold">Profils</h3>
      <div class="columns is-multiline">
        <span v-for="(profil, index) in profils" :key="index" class="column is-one-quarter">
          <b-field>
            <b-button
              class="is-size-8"
              rounded
              :type="typeButton({ profil })"
              :icon-right="iconCheck({ profil })"
              expanded
              @click="addRemoveProfil({ profil })"
              >{{ profil.description }}
            </b-button>
          </b-field>
          <span />
        </span>
      </div>
    </div>
    <div class="mt-fields-section">
      <h3 class="has-text-weight-bold">Informations sur le compte</h3>
      <div class="columns">
        <div class="column">
          <b-field label="Compte activé ">
            <b-checkbox v-model="utilisateur.enabled" />
          </b-field>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import DayMonthMixin from '~/components/mixins/DayMonthMixin';

export default {
  mixins: [DayMonthMixin],
  props: {
    utilisateur: {
      type: Object,
      default: () => ({}),
    },
    corps: {
      type: Array,
      default: () => [],
    },
    typesOrganismes: {
      type: Array,
      default: () => [],
    },
    organismes: {
      type: Array,
      default: () => [],
    },
    postesRo: {
      type: Array,
      default: () => [],
    },
    profils: {
      type: Array,
      default: () => [],
    },
    typeOrganismesAllowed: {
      type: Array,
      default: () => [],
    },
  },
  data() {
    return {
      isAdmin: this.$store.getters['context/isAdmin'],
    };
  },
  methods: {
    async majTypeOrganisme(index) {
      const idOrganismeSelectionner = this.organismes[index];
      if (this.typesOrganismes.length > index + 1) {
        for (let i = index + 1; i < this.typesOrganismes.length; i += 1) {
          this.typesOrganismes[i].organismes = {};
          this.organismes[i] = 0;
        }
        this.typesOrganismes[index + 1].organismes = await this.$api.organismes.organismesByParent(
          idOrganismeSelectionner,
        );
        if (this.isAdmin) {
          this.typesOrganismes[index + 1].organismes.unshift({ id: 0 });
        }
      }
      if (idOrganismeSelectionner !== 0) {
        this.utilisateur.affectation.organisme.id = idOrganismeSelectionner;
      } else {
        this.utilisateur.affectation.organisme.id = this.organismes[index - 1];
      }
    },
    typeButton({ profil }) {
      let ret = 'button is-light';
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code) {
          ret = 'button is-primary';
        }
      });
      return ret;
    },
    iconCheck({ profil }) {
      let ret = '';
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code && mProfil.selected) {
          ret = 'check';
        }
      });
      return ret;
    },
    switchProfil(profil, p1, p2) {
      if (profil.code === p1) {
        let i = 0;
        this.utilisateur.userProfils.forEach((mProfil) => {
          if (mProfil.profil.code === p2) {
            this.utilisateur.userProfils.splice(i, 1);
          }
          i += 1;
        });
      }
    },
    addRemoveProfil({ profil }) {
      let estDansSelect = false;
      let i = 0;
      let index = null;
      this.utilisateur.userProfils.forEach((mProfil) => {
        if (mProfil.profil.code === profil.code) {
          estDansSelect = true;
          index = i;
        }
        i += 1;
      });
      if (!estDansSelect) {
        this.utilisateur.userProfils.push({ profil, selected: false });
        this.switchProfil(profil, 'employeur', 'super_employeur');
        this.switchProfil(profil, 'super_employeur', 'employeur');
        this.switchProfil(profil, 'employe', 'super_employe');
        this.switchProfil(profil, 'super_employe', 'employe');
      } else if (this.utilisateur.userProfils.length > 1) {
        if (this.utilisateur.userProfils[index].selected) {
          if (index !== 0) {
            this.utilisateur.userProfils[0].selected = true;
          } else {
            this.utilisateur.userProfils[1].selected = true;
          }
        }
        this.utilisateur.userProfils.splice(index, 1);
      } else {
        this.$buefy.notification.open({
          message: "L'utilisateur doit avoir au minimum un profil",
          type: 'is-warning',
        });
      }
      if (this.utilisateur.userProfils.length === 1) {
        this.utilisateur.userProfils[0].selected = true;
      }
    },
    isUpdateOrganismeDisabled(idTypeOrganisme) {
      return (
        !this.isAdmin &&
        this.typeOrganismesAllowed.find((typeOrganisme) => typeOrganisme.id === idTypeOrganisme) === undefined
      );
    },
  },
};
</script>

<style scoped lang="scss">
h3 {
  font-weight: bold;
  margin-bottom: 1rem;
  text-transform: uppercase !important;
}

.mt-fields-section {
  margin-bottom: 1.25rem;
}

.mt-fake-field {
  margin-bottom: 0;
}

.mt-type {
  .control:not(:last-child) {
    margin-right: 1rem;
  }
}
</style>
